# coding: utf-8

"""
Slices User and Project Authority API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 0.0.1
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self


class User(BaseModel):
    """
    User
    """  # noqa: E501

    affiliation: StrictStr = Field(description="Affiliation")
    created_at: datetime
    email: Optional[StrictStr]
    first_name: StrictStr = Field(description="First Name")
    id: Annotated[str, Field(strict=True)]
    last_name: StrictStr = Field(description="Last Name")
    organisation: StrictStr = Field(description="Organisation")
    preferred_username: StrictStr = Field(description="Preferred Username")
    __properties: ClassVar[List[str]] = [
        "affiliation",
        "created_at",
        "email",
        "first_name",
        "id",
        "last_name",
        "organisation",
        "preferred_username",
    ]

    @field_validator("id")
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"user_[a-z][a-z0-9-.]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}", value):
            raise ValueError(
                r"must validate the regular expression /user_[a-z][a-z0-9-.]{1,55}_[01234567][0123456789abcdefghjkmnpqrstvwxyz]{25}/"
            )
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of User from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if email (nullable) is None
        # and model_fields_set contains the field
        if self.email is None and "email" in self.model_fields_set:
            _dict["email"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of User from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "affiliation": obj.get("affiliation"),
                "created_at": obj.get("created_at"),
                "email": obj.get("email"),
                "first_name": obj.get("first_name"),
                "id": obj.get("id"),
                "last_name": obj.get("last_name"),
                "organisation": obj.get("organisation"),
                "preferred_username": obj.get("preferred_username"),
            }
        )
        return _obj
